﻿// BandSplitorByGDAL.cpp : 此文件包含 "main" 函数。程序执行将在此处开始并结束。
//

#include <iostream>
#include <gdal.h>
#include <gdal_priv.h>

using namespace std;

// v是src文件，save文件是保存文件， bandIndex是需要的波段，1-n
void Spearation(string v, string save, int bandIndex)
{
	char path[1024];
	GDALAllRegister();
	GDALDataset* datasetRead = (GDALDataset*)GDALOpen(v.c_str(), GA_ReadOnly);
	GDALRasterBand* band = datasetRead->GetRasterBand(bandIndex);

	int width = band->GetXSize();
	int height = band->GetYSize();
	GDALDataType type = band->GetRasterDataType();
	sprintf(path, "%s/result_%d.tif",
		save.c_str(),
		bandIndex);

	//可以是GTiff 或者 ENVI等不同的驱动
	GDALDriver* driver = GetGDALDriverManager()->GetDriverByName("GTiff");
	GDALDataset* datasetWrite = driver->Create(path,
		width,
		height, 1,
		band->GetRasterDataType(), NULL);
	GDALRasterBand* writer = datasetWrite->GetRasterBand(1);

	unsigned char* pMemData = (unsigned char*)CPLMalloc(band->GetXSize() * 100);
	int endFlag = band->GetYSize() / 100;
	for (int i = 0; i < endFlag; i++)
	{
		band->RasterIO(
			GF_Read, 0, i * 100,
			width, 100, pMemData,
			height, 100, GDT_Byte,
			0, 0);

		writer->RasterIO(
			GF_Write, 0, i * 100,
			width, 100, pMemData,
			height, 100, GDT_Byte,
			0, 0);
	}
	CPLFree(pMemData);
	writer->FlushCache();
}

int main()
{
	cout << "begin to seperate file:" << endl;
	Spearation("E:\\0.tiff",
		"E:\\",
		5);
	cout << "finish to seperate file!" << endl;

	cout << "wait to write file!" << endl;
}
